;	================================================================================
							.Code
;	================================================================================

							ALIGN	4

;	================================================================================
;	01/03/2007	Philippe RIO (Grincheux) - www.stosd.com
;
;	Be careful, I recommend that you make a copy of the file to load before using this function.
;	If the resulting buffer is modified, the file content too.

;	Args :
;			__lpszFileToLoad		: LPSTR (The name of the file to load)
;			__lpOriginalFile		: PTR HANDLE (Pointer for the file handle)
;			__lpFileMappingObject	: PTR HANDLE (Pointer for the mapped file handle)
;
; Registers :
;			EAX	= Resulting buffer address or NULL if the function failms
;			EBX, EDI and ESI are preserved
;			All others registers can be modified by the function
;
;	Once you have finished with the bufer you must free memory and close files handles by calling "File_Unload"
;
;	ATTN :	Parameters begins with two underscores
;			Locals variables begins with one unerscores
;			Globals variables have no underscore

File_LoadEntire				PROC	USES EBX EDI ESI,__lpszFileToLoad:LPSTR,__lpOriginalFile:Ptr HANDLE,__lpFileMappingObject:Ptr HANDLE
							LOCAL	_hOriginalFile:HANDLE
							LOCAL	_hFileMappingObject:HANDLE

							mov		eax,__lpFileMappingObject

							test	eax,eax
							jz		@Error

							mov		eax,__lpOriginalFile

							test	eax,eax
							jz		@Error

							mov		eax,__lpszFileToLoad

							test	eax,eax
							jz		@Error

							INVOKE	PathFileExists,eax

							test	eax,eax
							jz		@Error

							INVOKE	CreateFile,__lpszFileToLoad,GENERIC_READ or GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL

							cmp		eax,INVALID_HANDLE_VALUE
							je		@Error

							mov		_hOriginalFile,eax

							mov		edx,__lpOriginalFile
							mov		[edx],eax

							INVOKE	CreateFileMapping,_hOriginalFile,NULL,PAGE_READWRITE,0,0,NULL

							test	eax,eax
							jz		@Error_1

							mov		_hFileMappingObject,eax

							mov		edx,__lpFileMappingObject
							mov		[edx],eax

							INVOKE	MapViewOfFile,_hFileMappingObject,FILE_MAP_ALL_ACCESS,0,0,0

							test	eax,eax
							jnz		@Exit

							INVOKE	CloseHandle,_hFileMappingObject

@Error_1 :

							INVOKE	CloseHandle,_hOriginalFile

@Error :

							xor		eax,eax

@Exit :

							ret
File_LoadEntire				ENDP

;	================================================================================
;	01/03/2007	Philippe RIO (Grincheux) - www.stosd.com
;
;	This function frees memory allocated by the File_LoadEntire function. It close the files handles too.
;
;	Args :
;		__lpBuffer				: LPBYTE	(Address of a buffer allocated by File_LoadEntire)
;		__hOriginalFile			: HANDLE	(Handle of the loaded file)
;		__hFileMappingObject	: HANDLE	(Handle to the mapped file)
;
;	ATTN :	Parameters begins with two underscores
;			Locals variables begins with one unerscores
;			Globals variables have no underscore
;	================================================================================

File_Unload					PROC	USES EBX EDI ESI,__lpBuffer:LPBYTE,__hOriginalFile:HANDLE,__hFileMappingObject:HANDLE

							INVOKE	UnmapViewOfFile,__lpBuffer

							INVOKE	CloseHandle,__hFileMappingObject
							INVOKE	CloseHandle,__hOriginalFile

							ret
File_Unload					ENDP

;	================================================================================

